package org.zeroturnaround.javarebel.integration.servlet.resin;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.javarebel.RebelServletContext;
import org.zeroturnaround.javarebel.integration.generic.BaseServletContextImplClassBytecodeProcessor;

/**
 * Transforms <code>com.caucho.server.webapp.WebApp</code> by registering Resin
 * servlet context instance with JavaRebel.
 * <p>
 * The transformed class exists since Resin 3.0.
 * 
 * @author Toomas Römer
 */
public class ResinContextHandlerCBP extends
    BaseServletContextImplClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    CtMethod m = ctClass.getMethod("init", "()V");
    m.insertAfter("org.zeroturnaround.javarebel.ServletIntegrationFactory.getInstance()"
        + "    .registerServletContext(("
        + RebelServletContext.class.getName()
        + ") $0);");
    
    super.process(cp, cl, ctClass);
  }
}
